const normalizeLine = line => {
  if (line.startsWith('Error: ')) {
    return line.slice('Error: '.length);
  }
  if (line.startsWith('VError: ')) {
    return line.slice('VError: '.length);
  }
  return line;
};
const getCombinedMessage = (error, message) => {
  const stringifiedError = normalizeLine(`${error}`);
  if (message) {
    return `${message}: ${stringifiedError}`;
  }
  return stringifiedError;
};
const NewLine$2 = '\n';
const getNewLineIndex$1 = (string, startIndex = undefined) => {
  return string.indexOf(NewLine$2, startIndex);
};
const mergeStacks = (parent, child) => {
  if (!child) {
    return parent;
  }
  const parentNewLineIndex = getNewLineIndex$1(parent);
  const childNewLineIndex = getNewLineIndex$1(child);
  if (childNewLineIndex === -1) {
    return parent;
  }
  const parentFirstLine = parent.slice(0, parentNewLineIndex);
  const childRest = child.slice(childNewLineIndex);
  const childFirstLine = normalizeLine(child.slice(0, childNewLineIndex));
  if (parentFirstLine.includes(childFirstLine)) {
    return parentFirstLine + childRest;
  }
  return child;
};
class VError extends Error {
  constructor(error, message) {
    const combinedMessage = getCombinedMessage(error, message);
    super(combinedMessage);
    this.name = 'VError';
    if (error instanceof Error) {
      this.stack = mergeStacks(this.stack, error.stack);
    }
    if (error.codeFrame) {
      // @ts-ignore
      this.codeFrame = error.codeFrame;
    }
    if (error.code) {
      // @ts-ignore
      this.code = error.code;
    }
  }
}

class AssertionError extends Error {
  constructor(message) {
    super(message);
    this.name = 'AssertionError';
  }
}
const Object$1 = 1;
const Number$1 = 2;
const Array$1 = 3;
const String = 4;
const Boolean$1 = 5;
const Function = 6;
const Null = 7;
const Unknown = 8;
const getType = value => {
  switch (typeof value) {
    case 'number':
      return Number$1;
    case 'function':
      return Function;
    case 'string':
      return String;
    case 'object':
      if (value === null) {
        return Null;
      }
      if (Array.isArray(value)) {
        return Array$1;
      }
      return Object$1;
    case 'boolean':
      return Boolean$1;
    default:
      return Unknown;
  }
};
const object = value => {
  const type = getType(value);
  if (type !== Object$1) {
    throw new AssertionError('expected value to be of type object');
  }
};
const number = value => {
  const type = getType(value);
  if (type !== Number$1) {
    throw new AssertionError('expected value to be of type number');
  }
};

const isMessagePort = value => {
  return value && value instanceof MessagePort;
};
const isMessagePortMain = value => {
  return value && value.constructor && value.constructor.name === 'MessagePortMain';
};
const isOffscreenCanvas = value => {
  return typeof OffscreenCanvas !== 'undefined' && value instanceof OffscreenCanvas;
};
const isInstanceOf = (value, constructorName) => {
  return value?.constructor?.name === constructorName;
};
const isSocket = value => {
  return isInstanceOf(value, 'Socket');
};
const transferrables = [isMessagePort, isMessagePortMain, isOffscreenCanvas, isSocket];
const isTransferrable = value => {
  for (const fn of transferrables) {
    if (fn(value)) {
      return true;
    }
  }
  return false;
};
const walkValue = (value, transferrables, isTransferrable) => {
  if (!value) {
    return;
  }
  if (isTransferrable(value)) {
    transferrables.push(value);
    return;
  }
  if (Array.isArray(value)) {
    for (const item of value) {
      walkValue(item, transferrables, isTransferrable);
    }
    return;
  }
  if (typeof value === 'object') {
    for (const property of Object.values(value)) {
      walkValue(property, transferrables, isTransferrable);
    }
    return;
  }
};
const getTransferrables = value => {
  const transferrables = [];
  walkValue(value, transferrables, isTransferrable);
  return transferrables;
};
const attachEvents = that => {
  const handleMessage = (...args) => {
    const data = that.getData(...args);
    that.dispatchEvent(new MessageEvent('message', {
      data
    }));
  };
  that.onMessage(handleMessage);
  const handleClose = event => {
    that.dispatchEvent(new Event('close'));
  };
  that.onClose(handleClose);
};
class Ipc extends EventTarget {
  constructor(rawIpc) {
    super();
    this._rawIpc = rawIpc;
    attachEvents(this);
  }
}
const E_INCOMPATIBLE_NATIVE_MODULE = 'E_INCOMPATIBLE_NATIVE_MODULE';
const E_MODULES_NOT_SUPPORTED_IN_ELECTRON = 'E_MODULES_NOT_SUPPORTED_IN_ELECTRON';
const ERR_MODULE_NOT_FOUND = 'ERR_MODULE_NOT_FOUND';
const NewLine$1 = '\n';
const joinLines$1 = lines => {
  return lines.join(NewLine$1);
};
const RE_AT = /^\s+at/;
const RE_AT_PROMISE_INDEX = /^\s*at async Promise.all \(index \d+\)$/;
const isNormalStackLine = line => {
  return RE_AT.test(line) && !RE_AT_PROMISE_INDEX.test(line);
};
const getDetails = lines => {
  const index = lines.findIndex(isNormalStackLine);
  if (index === -1) {
    return {
      actualMessage: joinLines$1(lines),
      rest: []
    };
  }
  let lastIndex = index - 1;
  while (++lastIndex < lines.length) {
    if (!isNormalStackLine(lines[lastIndex])) {
      break;
    }
  }
  return {
    actualMessage: lines[index - 1],
    rest: lines.slice(index, lastIndex)
  };
};
const splitLines$1 = lines => {
  return lines.split(NewLine$1);
};
const RE_MESSAGE_CODE_BLOCK_START = /^Error: The module '.*'$/;
const RE_MESSAGE_CODE_BLOCK_END = /^\s* at/;
const isMessageCodeBlockStartIndex = line => {
  return RE_MESSAGE_CODE_BLOCK_START.test(line);
};
const isMessageCodeBlockEndIndex = line => {
  return RE_MESSAGE_CODE_BLOCK_END.test(line);
};
const getMessageCodeBlock = stderr => {
  const lines = splitLines$1(stderr);
  const startIndex = lines.findIndex(isMessageCodeBlockStartIndex);
  const endIndex = startIndex + lines.slice(startIndex).findIndex(isMessageCodeBlockEndIndex, startIndex);
  const relevantLines = lines.slice(startIndex, endIndex);
  const relevantMessage = relevantLines.join(' ').slice('Error: '.length);
  return relevantMessage;
};
const isModuleNotFoundMessage = line => {
  return line.includes('[ERR_MODULE_NOT_FOUND]');
};
const getModuleNotFoundError = stderr => {
  const lines = splitLines$1(stderr);
  const messageIndex = lines.findIndex(isModuleNotFoundMessage);
  const message = lines[messageIndex];
  return {
    message,
    code: ERR_MODULE_NOT_FOUND
  };
};
const isModuleNotFoundError = stderr => {
  if (!stderr) {
    return false;
  }
  return stderr.includes('ERR_MODULE_NOT_FOUND');
};
const isModulesSyntaxError = stderr => {
  if (!stderr) {
    return false;
  }
  return stderr.includes('SyntaxError: Cannot use import statement outside a module');
};
const RE_NATIVE_MODULE_ERROR = /^innerError Error: Cannot find module '.*.node'/;
const RE_NATIVE_MODULE_ERROR_2 = /was compiled against a different Node.js version/;
const isUnhelpfulNativeModuleError = stderr => {
  return RE_NATIVE_MODULE_ERROR.test(stderr) && RE_NATIVE_MODULE_ERROR_2.test(stderr);
};
const getNativeModuleErrorMessage = stderr => {
  const message = getMessageCodeBlock(stderr);
  return {
    message: `Incompatible native node module: ${message}`,
    code: E_INCOMPATIBLE_NATIVE_MODULE
  };
};
const getModuleSyntaxError = () => {
  return {
    message: `ES Modules are not supported in electron`,
    code: E_MODULES_NOT_SUPPORTED_IN_ELECTRON
  };
};
const getHelpfulChildProcessError = (stdout, stderr) => {
  if (isUnhelpfulNativeModuleError(stderr)) {
    return getNativeModuleErrorMessage(stderr);
  }
  if (isModulesSyntaxError(stderr)) {
    return getModuleSyntaxError();
  }
  if (isModuleNotFoundError(stderr)) {
    return getModuleNotFoundError(stderr);
  }
  const lines = splitLines$1(stderr);
  const {
    actualMessage,
    rest
  } = getDetails(lines);
  return {
    message: actualMessage,
    code: '',
    stack: rest
  };
};
class IpcError extends VError {
  // @ts-ignore
  constructor(betterMessage, stdout = '', stderr = '') {
    if (stdout || stderr) {
      // @ts-ignore
      const {
        message,
        code,
        stack
      } = getHelpfulChildProcessError(stdout, stderr);
      const cause = new Error(message);
      // @ts-ignore
      cause.code = code;
      cause.stack = stack;
      super(cause, betterMessage);
    } else {
      super(betterMessage);
    }
    // @ts-ignore
    this.name = 'IpcError';
    // @ts-ignore
    this.stdout = stdout;
    // @ts-ignore
    this.stderr = stderr;
  }
}
const readyMessage = 'ready';
const getData$2 = event => {
  return event.data;
};
const listen$7 = () => {
  // @ts-ignore
  if (typeof WorkerGlobalScope === 'undefined') {
    throw new TypeError('module is not in web worker scope');
  }
  return globalThis;
};
const signal$8 = global => {
  global.postMessage(readyMessage);
};
class IpcChildWithModuleWorker extends Ipc {
  getData(event) {
    return getData$2(event);
  }
  send(message) {
    // @ts-ignore
    this._rawIpc.postMessage(message);
  }
  sendAndTransfer(message) {
    const transfer = getTransferrables(message);
    // @ts-ignore
    this._rawIpc.postMessage(message, transfer);
  }
  dispose() {
    // ignore
  }
  onClose(callback) {
    // ignore
  }
  onMessage(callback) {
    this._rawIpc.addEventListener('message', callback);
  }
}
const wrap$f = global => {
  return new IpcChildWithModuleWorker(global);
};
const waitForFirstMessage = async port => {
  const {
    resolve,
    promise
  } = Promise.withResolvers();
  port.addEventListener('message', resolve, {
    once: true
  });
  const event = await promise;
  // @ts-ignore
  return event.data;
};
const listen$6 = async () => {
  const parentIpcRaw = listen$7();
  signal$8(parentIpcRaw);
  const parentIpc = wrap$f(parentIpcRaw);
  const firstMessage = await waitForFirstMessage(parentIpc);
  if (firstMessage.method !== 'initialize') {
    throw new IpcError('unexpected first message');
  }
  const type = firstMessage.params[0];
  if (type === 'message-port') {
    parentIpc.send({
      jsonrpc: '2.0',
      id: firstMessage.id,
      result: null
    });
    parentIpc.dispose();
    const port = firstMessage.params[1];
    return port;
  }
  return globalThis;
};
class IpcChildWithModuleWorkerAndMessagePort extends Ipc {
  getData(event) {
    return getData$2(event);
  }
  send(message) {
    this._rawIpc.postMessage(message);
  }
  sendAndTransfer(message) {
    const transfer = getTransferrables(message);
    this._rawIpc.postMessage(message, transfer);
  }
  dispose() {
    if (this._rawIpc.close) {
      this._rawIpc.close();
    }
  }
  onClose(callback) {
    // ignore
  }
  onMessage(callback) {
    this._rawIpc.addEventListener('message', callback);
    this._rawIpc.start();
  }
}
const wrap$e = port => {
  return new IpcChildWithModuleWorkerAndMessagePort(port);
};
const IpcChildWithModuleWorkerAndMessagePort$1 = {
  __proto__: null,
  listen: listen$6,
  wrap: wrap$e
};
const addListener = (emitter, type, callback) => {
  if ('addEventListener' in emitter) {
    emitter.addEventListener(type, callback);
  } else {
    emitter.on(type, callback);
  }
};
const removeListener = (emitter, type, callback) => {
  if ('removeEventListener' in emitter) {
    emitter.removeEventListener(type, callback);
  } else {
    emitter.off(type, callback);
  }
};
const getFirstEvent = (eventEmitter, eventMap) => {
  const {
    resolve,
    promise
  } = Promise.withResolvers();
  const listenerMap = Object.create(null);
  const cleanup = value => {
    for (const event of Object.keys(eventMap)) {
      removeListener(eventEmitter, event, listenerMap[event]);
    }
    resolve(value);
  };
  for (const [event, type] of Object.entries(eventMap)) {
    const listener = event => {
      cleanup({
        type,
        event
      });
    };
    addListener(eventEmitter, event, listener);
    listenerMap[event] = listener;
  }
  return promise;
};
const Message$1 = 3;
const create$5$1 = async ({
  messagePort,
  isMessagePortOpen
}) => {
  if (!isMessagePort(messagePort)) {
    throw new IpcError('port must be of type MessagePort');
  }
  if (isMessagePortOpen) {
    return messagePort;
  }
  const eventPromise = getFirstEvent(messagePort, {
    message: Message$1
  });
  messagePort.start();
  const {
    type,
    event
  } = await eventPromise;
  if (type !== Message$1) {
    throw new IpcError('Failed to wait for ipc message');
  }
  if (event.data !== readyMessage) {
    throw new IpcError('unexpected first message');
  }
  return messagePort;
};
const signal$1 = messagePort => {
  messagePort.start();
};
class IpcParentWithMessagePort extends Ipc {
  getData = getData$2;
  send(message) {
    this._rawIpc.postMessage(message);
  }
  sendAndTransfer(message) {
    const transfer = getTransferrables(message);
    this._rawIpc.postMessage(message, transfer);
  }
  dispose() {
    this._rawIpc.close();
  }
  onMessage(callback) {
    this._rawIpc.addEventListener('message', callback);
  }
  onClose(callback) {}
}
const wrap$5 = messagePort => {
  return new IpcParentWithMessagePort(messagePort);
};
const IpcParentWithMessagePort$1 = {
  __proto__: null,
  create: create$5$1,
  signal: signal$1,
  wrap: wrap$5
};

const Two = '2.0';
const create$4$1 = (method, params) => {
  return {
    jsonrpc: Two,
    method,
    params
  };
};
const callbacks = Object.create(null);
const set$3 = (id, fn) => {
  callbacks[id] = fn;
};
const get$2 = id => {
  return callbacks[id];
};
const remove = id => {
  delete callbacks[id];
};
let id = 0;
const create$3$1 = () => {
  return ++id;
};
const registerPromise = () => {
  const id = create$3$1();
  const {
    resolve,
    promise
  } = Promise.withResolvers();
  set$3(id, resolve);
  return {
    id,
    promise
  };
};
const create$2$1 = (method, params) => {
  const {
    id,
    promise
  } = registerPromise();
  const message = {
    jsonrpc: Two,
    method,
    params,
    id
  };
  return {
    message,
    promise
  };
};
class JsonRpcError extends Error {
  constructor(message) {
    super(message);
    this.name = 'JsonRpcError';
  }
}
const NewLine = '\n';
const DomException = 'DOMException';
const ReferenceError$1 = 'ReferenceError';
const SyntaxError$1 = 'SyntaxError';
const TypeError$1 = 'TypeError';
const getErrorConstructor = (message, type) => {
  if (type) {
    switch (type) {
      case DomException:
        return DOMException;
      case TypeError$1:
        return TypeError;
      case SyntaxError$1:
        return SyntaxError;
      case ReferenceError$1:
        return ReferenceError;
      default:
        return Error;
    }
  }
  if (message.startsWith('TypeError: ')) {
    return TypeError;
  }
  if (message.startsWith('SyntaxError: ')) {
    return SyntaxError;
  }
  if (message.startsWith('ReferenceError: ')) {
    return ReferenceError;
  }
  return Error;
};
const constructError = (message, type, name) => {
  const ErrorConstructor = getErrorConstructor(message, type);
  if (ErrorConstructor === DOMException && name) {
    return new ErrorConstructor(message, name);
  }
  if (ErrorConstructor === Error) {
    const error = new Error(message);
    if (name && name !== 'VError') {
      error.name = name;
    }
    return error;
  }
  return new ErrorConstructor(message);
};
const joinLines = lines => {
  return lines.join(NewLine);
};
const splitLines = lines => {
  return lines.split(NewLine);
};
const getCurrentStack = () => {
  const stackLinesToSkip = 3;
  const currentStack = joinLines(splitLines(new Error().stack || '').slice(stackLinesToSkip));
  return currentStack;
};
const getNewLineIndex = (string, startIndex = undefined) => {
  return string.indexOf(NewLine, startIndex);
};
const getParentStack = error => {
  let parentStack = error.stack || error.data || error.message || '';
  if (parentStack.startsWith('    at')) {
    parentStack = error.message + NewLine + parentStack;
  }
  return parentStack;
};
const MethodNotFound = -32601;
const Custom = -32001;
const restoreJsonRpcError = error => {
  const currentStack = getCurrentStack();
  if (error && error instanceof Error) {
    if (typeof error.stack === 'string') {
      error.stack = error.stack + NewLine + currentStack;
    }
    return error;
  }
  if (error && error.code && error.code === MethodNotFound) {
    const restoredError = new JsonRpcError(error.message);
    const parentStack = getParentStack(error);
    restoredError.stack = parentStack + NewLine + currentStack;
    return restoredError;
  }
  if (error && error.message) {
    const restoredError = constructError(error.message, error.type, error.name);
    if (error.data) {
      if (error.data.stack && error.data.type && error.message) {
        restoredError.stack = error.data.type + ': ' + error.message + NewLine + error.data.stack + NewLine + currentStack;
      } else if (error.data.stack) {
        restoredError.stack = error.data.stack;
      }
      if (error.data.codeFrame) {
        // @ts-ignore
        restoredError.codeFrame = error.data.codeFrame;
      }
      if (error.data.code) {
        // @ts-ignore
        restoredError.code = error.data.code;
      }
      if (error.data.type) {
        // @ts-ignore
        restoredError.name = error.data.type;
      }
    } else {
      if (error.stack) {
        const lowerStack = restoredError.stack || '';
        // @ts-ignore
        const indexNewLine = getNewLineIndex(lowerStack);
        const parentStack = getParentStack(error);
        // @ts-ignore
        restoredError.stack = parentStack + lowerStack.slice(indexNewLine);
      }
      if (error.codeFrame) {
        // @ts-ignore
        restoredError.codeFrame = error.codeFrame;
      }
    }
    return restoredError;
  }
  if (typeof error === 'string') {
    return new Error(`JsonRpc Error: ${error}`);
  }
  return new Error(`JsonRpc Error: ${error}`);
};
const unwrapJsonRpcResult = responseMessage => {
  if ('error' in responseMessage) {
    const restoredError = restoreJsonRpcError(responseMessage.error);
    throw restoredError;
  }
  if ('result' in responseMessage) {
    return responseMessage.result;
  }
  throw new JsonRpcError('unexpected response message');
};
const warn = (...args) => {
  console.warn(...args);
};
const resolve = (id, response) => {
  const fn = get$2(id);
  if (!fn) {
    console.log(response);
    warn(`callback ${id} may already be disposed`);
    return;
  }
  fn(response);
  remove(id);
};
const E_COMMAND_NOT_FOUND = 'E_COMMAND_NOT_FOUND';
const getErrorType = prettyError => {
  if (prettyError && prettyError.type) {
    return prettyError.type;
  }
  if (prettyError && prettyError.constructor && prettyError.constructor.name) {
    return prettyError.constructor.name;
  }
  return undefined;
};
const isAlreadyStack = line => {
  return line.trim().startsWith('at ');
};
const getStack = prettyError => {
  const stackString = prettyError.stack || '';
  const newLineIndex = stackString.indexOf('\n');
  if (newLineIndex !== -1 && !isAlreadyStack(stackString.slice(0, newLineIndex))) {
    return stackString.slice(newLineIndex + 1);
  }
  return stackString;
};
const getErrorProperty = (error, prettyError) => {
  if (error && error.code === E_COMMAND_NOT_FOUND) {
    return {
      code: MethodNotFound,
      message: error.message,
      data: error.stack
    };
  }
  return {
    code: Custom,
    message: prettyError.message,
    data: {
      stack: getStack(prettyError),
      codeFrame: prettyError.codeFrame,
      type: getErrorType(prettyError),
      code: prettyError.code,
      name: prettyError.name
    }
  };
};
const create$1$1 = (id, error) => {
  return {
    jsonrpc: Two,
    id,
    error
  };
};
const getErrorResponse = (id, error, preparePrettyError, logError) => {
  const prettyError = preparePrettyError(error);
  logError(error, prettyError);
  const errorProperty = getErrorProperty(error, prettyError);
  return create$1$1(id, errorProperty);
};
const create$6 = (message, result) => {
  return {
    jsonrpc: Two,
    id: message.id,
    result: result ?? null
  };
};
const getSuccessResponse = (message, result) => {
  const resultProperty = result ?? null;
  return create$6(message, resultProperty);
};
const getErrorResponseSimple = (id, error) => {
  return {
    jsonrpc: Two,
    id,
    error: {
      code: Custom,
      // @ts-ignore
      message: error.message,
      data: error
    }
  };
};
const getResponse = async (message, ipc, execute, preparePrettyError, logError, requiresSocket) => {
  try {
    const result = requiresSocket(message.method) ? await execute(message.method, ipc, ...message.params) : await execute(message.method, ...message.params);
    return getSuccessResponse(message, result);
  } catch (error) {
    if (ipc.canUseSimpleErrorResponse) {
      return getErrorResponseSimple(message.id, error);
    }
    return getErrorResponse(message.id, error, preparePrettyError, logError);
  }
};
const defaultPreparePrettyError = error => {
  return error;
};
const defaultLogError = () => {
  // ignore
};
const defaultRequiresSocket = () => {
  return false;
};
const defaultResolve = resolve;

// TODO maybe remove this in v6 or v7, only accept options object to simplify the code
const normalizeParams = args => {
  if (args.length === 1) {
    const options = args[0];
    return {
      ipc: options.ipc,
      message: options.message,
      execute: options.execute,
      resolve: options.resolve || defaultResolve,
      preparePrettyError: options.preparePrettyError || defaultPreparePrettyError,
      logError: options.logError || defaultLogError,
      requiresSocket: options.requiresSocket || defaultRequiresSocket
    };
  }
  return {
    ipc: args[0],
    message: args[1],
    execute: args[2],
    resolve: args[3],
    preparePrettyError: args[4],
    logError: args[5],
    requiresSocket: args[6]
  };
};
const handleJsonRpcMessage = async (...args) => {
  const options = normalizeParams(args);
  const {
    message,
    ipc,
    execute,
    resolve,
    preparePrettyError,
    logError,
    requiresSocket
  } = options;
  if ('id' in message) {
    if ('method' in message) {
      const response = await getResponse(message, ipc, execute, preparePrettyError, logError, requiresSocket);
      try {
        ipc.send(response);
      } catch (error) {
        const errorResponse = getErrorResponse(message.id, error, preparePrettyError, logError);
        ipc.send(errorResponse);
      }
      return;
    }
    resolve(message.id, message);
    return;
  }
  if ('method' in message) {
    await getResponse(message, ipc, execute, preparePrettyError, logError, requiresSocket);
    return;
  }
  throw new JsonRpcError('unexpected message');
};
const invokeHelper = async (ipc, method, params, useSendAndTransfer) => {
  const {
    message,
    promise
  } = create$2$1(method, params);
  if (useSendAndTransfer && ipc.sendAndTransfer) {
    ipc.sendAndTransfer(message);
  } else {
    ipc.send(message);
  }
  const responseMessage = await promise;
  return unwrapJsonRpcResult(responseMessage);
};
const send = (transport, method, ...params) => {
  const message = create$4$1(method, params);
  transport.send(message);
};
const invoke$2 = (ipc, method, ...params) => {
  return invokeHelper(ipc, method, params, false);
};
const invokeAndTransfer$1 = (ipc, method, ...params) => {
  return invokeHelper(ipc, method, params, true);
};

class CommandNotFoundError extends Error {
  constructor(command) {
    super(`Command not found ${command}`);
    this.name = 'CommandNotFoundError';
  }
}
const commands = Object.create(null);
const register = commandMap => {
  Object.assign(commands, commandMap);
};
const getCommand$1 = key => {
  return commands[key];
};
const execute = (command, ...args) => {
  const fn = getCommand$1(command);
  if (!fn) {
    throw new CommandNotFoundError(command);
  }
  return fn(...args);
};

const createRpc = ipc => {
  const rpc = {
    // @ts-ignore
    ipc,
    /**
     * @deprecated
     */
    send(method, ...params) {
      send(ipc, method, ...params);
    },
    invoke(method, ...params) {
      return invoke$2(ipc, method, ...params);
    },
    invokeAndTransfer(method, ...params) {
      return invokeAndTransfer$1(ipc, method, ...params);
    },
    async dispose() {
      await ipc?.dispose();
    }
  };
  return rpc;
};
const requiresSocket = () => {
  return false;
};
const preparePrettyError = error => {
  return error;
};
const logError = () => {
  // handled by renderer worker
};
const handleMessage = event => {
  const actualRequiresSocket = event?.target?.requiresSocket || requiresSocket;
  const actualExecute = event?.target?.execute || execute;
  return handleJsonRpcMessage(event.target, event.data, actualExecute, resolve, preparePrettyError, logError, actualRequiresSocket);
};
const handleIpc = ipc => {
  if ('addEventListener' in ipc) {
    ipc.addEventListener('message', handleMessage);
  } else if ('on' in ipc) {
    // deprecated
    ipc.on('message', handleMessage);
  }
};
const listen$1 = async (module, options) => {
  const rawIpc = await module.listen(options);
  if (module.signal) {
    module.signal(rawIpc);
  }
  const ipc = module.wrap(rawIpc);
  return ipc;
};
const create$5 = async ({
  commandMap,
  messagePort
}) => {
  // TODO create a commandMap per rpc instance
  register(commandMap);
  const rawIpc = await IpcParentWithMessagePort$1.create({
    messagePort,
    isMessagePortOpen: true
  });
  const ipc = IpcParentWithMessagePort$1.wrap(rawIpc);
  handleIpc(ipc);
  const rpc = createRpc(ipc);
  messagePort.start();
  return rpc;
};
const create$3 = async ({
  commandMap,
  send
}) => {
  const {
    port1,
    port2
  } = new MessageChannel();
  await send(port1);
  return create$5({
    commandMap,
    messagePort: port2
  });
};
const TransferMessagePortRpcParent = {
  __proto__: null,
  create: create$3
};
const create$4 = async ({
  commandMap
}) => {
  // TODO create a commandMap per rpc instance
  register(commandMap);
  const ipc = await listen$1(IpcChildWithModuleWorkerAndMessagePort$1);
  handleIpc(ipc);
  const rpc = createRpc(ipc);
  return rpc;
};
const WebWorkerRpcClient = {
  __proto__: null,
  create: create$4
};

const toCommandId = key => {
  const dotIndex = key.indexOf('.');
  return key.slice(dotIndex + 1);
};
const create$2 = () => {
  const states = Object.create(null);
  const commandMapRef = {};
  return {
    get(uid) {
      return states[uid];
    },
    set(uid, oldState, newState) {
      states[uid] = {
        oldState,
        newState
      };
    },
    dispose(uid) {
      delete states[uid];
    },
    getKeys() {
      return Object.keys(states).map(key => {
        return Number.parseInt(key);
      });
    },
    clear() {
      for (const key of Object.keys(states)) {
        delete states[key];
      }
    },
    wrapCommand(fn) {
      const wrapped = async (uid, ...args) => {
        const {
          newState
        } = states[uid];
        const newerState = await fn(newState, ...args);
        if (newState === newerState) {
          return;
        }
        const latest = states[uid];
        states[uid] = {
          oldState: latest.oldState,
          newState: newerState
        };
      };
      return wrapped;
    },
    wrapGetter(fn) {
      const wrapped = (uid, ...args) => {
        const {
          newState
        } = states[uid];
        return fn(newState, ...args);
      };
      return wrapped;
    },
    diff(uid, modules, numbers) {
      const {
        oldState,
        newState
      } = states[uid];
      const diffResult = [];
      for (let i = 0; i < modules.length; i++) {
        const fn = modules[i];
        if (!fn(oldState, newState)) {
          diffResult.push(numbers[i]);
        }
      }
      return diffResult;
    },
    getCommandIds() {
      const keys = Object.keys(commandMapRef);
      const ids = keys.map(toCommandId);
      return ids;
    },
    registerCommands(commandMap) {
      Object.assign(commandMapRef, commandMap);
    }
  };
};
const terminate = () => {
  globalThis.close();
};

const rpcs = Object.create(null);
const set$g = (id, rpc) => {
  rpcs[id] = rpc;
};
const get$1 = id => {
  return rpcs[id];
};

/* eslint-disable  @typescript-eslint/explicit-function-return-type */

const create$1 = rpcId => {
  return {
    // @ts-ignore
    invoke(method, ...params) {
      const rpc = get$1(rpcId);
      // @ts-ignore
      return rpc.invoke(method, ...params);
    },
    // @ts-ignore
    invokeAndTransfer(method, ...params) {
      const rpc = get$1(rpcId);
      // @ts-ignore
      return rpc.invokeAndTransfer(method, ...params);
    },
    set(rpc) {
      set$g(rpcId, rpc);
    },
    async dispose() {
      const rpc = get$1(rpcId);
      await rpc.dispose();
    }
  };
};
const EditorWorker$1 = 99;
const ExtensionHostWorker = 44;
const {
  invoke: invoke$c,
  invokeAndTransfer: invokeAndTransfer$c,
  set: set$c,
  dispose: dispose$c
} = create$1(EditorWorker$1);
const sendMessagePortToExtensionHostWorker$1$1 = async port => {
  const command = 'HandleMessagePort.handleMessagePort2';
  await invokeAndTransfer$c(
  // @ts-ignore
  'SendMessagePortToExtensionHostWorker.sendMessagePortToExtensionHostWorker', port, command, 0 // TODO
  );
};

// TODO add tests for this
const activateByEvent$1 = async event => {
  // @ts-ignore
  await invoke$c('ActivateByEvent.activateByEvent', event);
};
const applyEdit$2 = async (editorUid, changes) => {
  // @ts-ignore
  await invoke$c('Editor.applyEdit2', editorUid, changes);
};
const closeWidget$1 = async (editorUid, widgetId, widgetName, focusId) => {
  // @ts-ignore
  await invoke$c('Editor.closeWidget2', editorUid, widgetId, widgetName, focusId);
};
const getWordAt$1 = async (uid, rowIndex, columnIndex) => {
  // @ts-ignore
  const word = await invoke$c('Editor.getWordAt2', uid, rowIndex, columnIndex);
  return word;
};
const getLines$1 = async editorUid => {
  const lines = await invoke$c('Editor.getLines2', editorUid);
  return lines;
};
const getPositionAtCursor$2 = async parentUid => {
  const position = await invoke$c('Editor.getPositionAtCursor', parentUid);
  return position;
};
const getOffsetAtCursor$1 = async editorId => {
  // @ts-ignore
  return await invoke$c('Editor.getOffsetAtCursor', editorId);
};
const getSelections$1 = async editorUid => {
  const selections = await invoke$c('Editor.getSelections2', editorUid);
  return selections;
};
const getWordAtOffset2$1 = async editorUid => {
  return invoke$c('Editor.getWordAtOffset2', editorUid);
};
const getWordBefore$1 = async (editorUid, rowIndex, columnIndex) => {
  return invoke$c('Editor.getWordBefore2', editorUid, rowIndex, columnIndex);
};
const EditorWorker$2 = {
  __proto__: null,
  activateByEvent: activateByEvent$1,
  applyEdit: applyEdit$2,
  closeWidget: closeWidget$1,
  dispose: dispose$c,
  getLines: getLines$1,
  getOffsetAtCursor: getOffsetAtCursor$1,
  getPositionAtCursor: getPositionAtCursor$2,
  getSelections: getSelections$1,
  getWordAt: getWordAt$1,
  getWordAtOffset2: getWordAtOffset2$1,
  getWordBefore: getWordBefore$1,
  invoke: invoke$c,
  invokeAndTransfer: invokeAndTransfer$c,
  sendMessagePortToExtensionHostWorker: sendMessagePortToExtensionHostWorker$1$1,
  set: set$c};
const {
  invoke: invoke$9,
  set: set$9} = create$1(ExtensionHostWorker);
const ExtensionHost = {
  __proto__: null,
  invoke: invoke$9,
  set: set$9
};

const {
  activateByEvent,
  applyEdit: applyEdit$1,
  closeWidget,
  dispose: dispose$2,
  getLines,
  getOffsetAtCursor,
  getPositionAtCursor: getPositionAtCursor$1,
  getSelections,
  getWordAt,
  getWordAtOffset2,
  getWordBefore,
  invoke: invoke$1,
  invokeAndTransfer,
  sendMessagePortToExtensionHostWorker: sendMessagePortToExtensionHostWorker$1,
  set: set$2
} = EditorWorker$2;

const EditorWorker = {
  __proto__: null,
  activateByEvent,
  applyEdit: applyEdit$1,
  closeWidget,
  dispose: dispose$2,
  getLines,
  getOffsetAtCursor,
  getPositionAtCursor: getPositionAtCursor$1,
  getSelections,
  getWordAt,
  getWordAtOffset2,
  getWordBefore,
  invoke: invoke$1,
  invokeAndTransfer,
  sendMessagePortToExtensionHostWorker: sendMessagePortToExtensionHostWorker$1,
  set: set$2
};

const FocusEditorCompletions = 9;
const FocusEditorRename = 11;
const FocusSourceActions = 38;

const Completion = 3;
const SourceAction$1 = 8;

const close = async state => {
  const {
    editorUid
  } = state;
  await closeWidget(editorUid, SourceAction$1, 'SourceActions', FocusSourceActions);
  return state;
};

const {
  dispose: dispose$1,
  get,
  getCommandIds,
  registerCommands,
  set: set$1,
  wrapCommand
} = create$2();

const create = (uid, x, y, width, height, editorUid, editorLanguageId) => {
  const state = {
    borderSize: 0,
    content: '',
    deltaY: 0,
    editorLanguageId,
    editorUid,
    finalDeltaY: 0,
    focused: false,
    focusedIndex: -1,
    headerHeight: 0,
    height: 0,
    itemHeight: 24,
    items: [],
    leadingWord: '',
    maxHeight: 150,
    maxItems: 8,
    maxLineY: 0,
    minLineY: 0,
    uid,
    version: 0,
    width: 0,
    x: 0,
    y: 0
  };
  set$1(uid, state, state);
};

const isEqual$4 = (oldState, newState) => {
  return oldState.x === newState.x && oldState.y === newState.y && oldState.width === newState.width && oldState.height === newState.height;
};

const isEqual$3 = (oldState, newState) => {
  return oldState.version === newState.version;
};

const isEqual$2 = (oldState, newState) => {
  return oldState.version === newState.version;
};

const isEqual$1 = (oldState, newState) => {
  return oldState.items === newState.items && oldState.focusedIndex === newState.focusedIndex && oldState.minLineY === newState.minLineY && oldState.maxLineY === newState.maxLineY;
};

const isEqual = (oldState, newState) => {
  return oldState.version === newState.version;
};

const RenderItems = 1;
const RenderBounds = 8;
const RenderEventListeners = 11;
const RenderUid = 12;
const RenderContent = 13;
const RenderFocusContext = 14;

const modules = [isEqual$3, isEqual$1, isEqual$4, isEqual, isEqual$2];
const numbers = [RenderEventListeners, RenderItems, RenderBounds, RenderUid, RenderFocusContext];

const diff = (oldState, newState) => {
  const diffResult = [];
  for (let i = 0; i < modules.length; i++) {
    const fn = modules[i];
    if (!fn(oldState, newState)) {
      diffResult.push(numbers[i]);
    }
  }
  return diffResult;
};

const diff2 = uid => {
  const {
    newState,
    oldState
  } = get(uid);
  const diffResult = diff(oldState, newState);
  return diffResult;
};

const dispose = uid => {
  dispose$1(uid);
};

const Enter = 3;
const Escape = 8;
const Space = 9;
const End = 255;
const Home = 12;
const UpArrow = 14;
const DownArrow = 16;
const KeyCode = {
  __proto__: null,
  DownArrow,
  End,
  Enter,
  Escape,
  Home,
  Space,
  UpArrow
};
const CtrlCmd = 1 << 11 >>> 0;
const KeyModifier = {
  __proto__: null,
  CtrlCmd};
const mergeClassNames = (...classNames) => {
  return classNames.filter(Boolean).join(' ');
};
const Text = 12;
const text = data => {
  return {
    type: Text,
    text: data,
    childCount: 0
  };
};

const getCommand = shortId => {
  return {
    args: ['Completions', `Completions.${shortId}`, 0, Completion],
    command: 'Editor.executeWidgetCommand'
  };
};
const getKeyBindings = () => {
  return [{
    key: KeyCode.DownArrow,
    ...getCommand('focusNext'),
    when: FocusEditorCompletions
  }, {
    key: KeyCode.UpArrow,
    ...getCommand('focusPrevious'),
    when: FocusEditorCompletions
  }, {
    key: KeyCode.Enter,
    ...getCommand('selectCurrent'),
    when: FocusEditorCompletions
  }, {
    key: KeyCode.End,
    ...getCommand('focusLast'),
    when: FocusEditorCompletions
  }, {
    key: KeyCode.Home,
    ...getCommand('focusFirst'),
    when: FocusEditorCompletions
  }, {
    key: KeyModifier.CtrlCmd | KeyCode.Space,
    ...getCommand('toggleDetails'),
    when: FocusEditorCompletions
  }, {
    key: KeyCode.Escape,
    ...getCommand('close'),
    when: FocusEditorCompletions
  }];
};

const handleEditorDeleteLeft = async state => {
  return state;
};

const handleEditorType = async state => {
  return state;
};

const clamp = (num, min, max) => {
  number(num);
  number(min);
  number(max);
  return Math.min(Math.max(num, min), max);
};

// TODO optimize this function to return the minimum number
// of visible items needed, e.g. when not scrolled 5 items with
// 20px fill 100px but when scrolled 6 items are needed
const getNumberOfVisibleItems = (listHeight, itemHeight) => {
  return Math.ceil(listHeight / itemHeight) + 1;
};

const getNewOffsets = (itemHeight, finalDeltaY, deltaY, height, headerHeight, value, itemCount) => {
  const listHeight = height - headerHeight;
  const newDeltaY = clamp(value, 0, finalDeltaY);
  if (deltaY === newDeltaY) {
    return {
      modified: false,
      newDeltaY: 0,
      newMaxLineY: 0,
      newMinLineY: 0
    };
  }
  // TODO when it only moves by one px, items don't need to be rerendered, only negative margin
  const minLineY = Math.floor(newDeltaY / itemHeight);
  const maxLineY = Math.min(minLineY + getNumberOfVisibleItems(listHeight, itemHeight), itemCount - 1);
  return {
    modified: true,
    newDeltaY: newDeltaY,
    newMaxLineY: maxLineY,
    newMinLineY: minLineY
  };
};

const setDeltaY = (state, value) => {
  object(state);
  number(value);
  const {
    deltaY,
    finalDeltaY,
    headerHeight,
    height,
    itemHeight,
    items
  } = state;
  const {
    modified,
    newDeltaY,
    newMaxLineY,
    newMinLineY
  } = getNewOffsets(itemHeight, finalDeltaY, deltaY, height, headerHeight, value, items.length);
  if (!modified) {
    return state;
  }
  return {
    ...state,
    deltaY: newDeltaY,
    maxLineY: newMaxLineY,
    minLineY: newMinLineY
  };
};

const handleWheel = (state, deltaMode, deltaY) => {
  number(deltaMode);
  number(deltaY);
  return setDeltaY(state, state.deltaY + deltaY);
};

const {
  sendMessagePortToExtensionHostWorker
} = EditorWorker;

const createExtensionHostRpc = async () => {
  try {
    const rpc = await TransferMessagePortRpcParent.create({
      commandMap: {},
      send: sendMessagePortToExtensionHostWorker
    });
    return rpc;
  } catch (error) {
    throw new VError(error, `Failed to create extension host rpc`);
  }
};

const {
  invoke,
  set
} = ExtensionHost;

const initialize = async () => {
  const rpc = await createExtensionHostRpc();
  set(rpc);
};

const getFinalDeltaY = (height, itemHeight, itemsLength) => {
  const contentHeight = itemsLength * itemHeight;
  const finalDeltaY = Math.max(contentHeight - height, 0);
  return finalDeltaY;
};

const getListHeight = (itemsLength, itemHeight, maxHeight) => {
  number(itemsLength);
  number(itemHeight);
  number(maxHeight);
  const emptyMessageHeight = 40;
  if (itemsLength === 0) {
    return emptyMessageHeight;
  }
  const headerHeight = 26;
  const paddingBottom = 5;
  const totalHeight = itemsLength * itemHeight + headerHeight + paddingBottom;
  return Math.min(totalHeight, maxHeight);
};

const {
  getPositionAtCursor
} = EditorWorker;

// TODO ask extension host worker instead
const getEditorSourceActions = async editorId => {
  // @ts-ignore
  const sourceActions = await invoke$1('Editor.getSourceActions', editorId);
  // @ts-ignore
  return sourceActions;
};

const getWordAtOffset = getWordAtOffset2;

const loadContent = async state => {
  const {
    editorUid,
    itemHeight,
    maxHeight
  } = state;
  const wordAtOffset = await getWordAtOffset(editorUid);
  const {
    columnIndex,
    rowIndex,
    x,
    y
  } = await getPositionAtCursor(editorUid);
  const actions = await getEditorSourceActions(editorUid);
  const items = actions;
  const newMaxLineY = Math.min(items.length, 8);
  const itemsLength = items.length;
  const newFocusedIndex = itemsLength === 0 ? -1 : 0;
  const total = items.length;
  const height = getListHeight(items.length, itemHeight, maxHeight);
  const finalDeltaY = getFinalDeltaY(height, itemHeight, total);
  return {
    ...state,
    // @ts-ignore
    columnIndex,
    finalDeltaY,
    focusedIndex: newFocusedIndex,
    height,
    items,
    leadingWord: wordAtOffset,
    maxLineY: newMaxLineY,
    rowIndex,
    version: 1,
    width: 200,
    x,
    y
  };
};

const SetBounds = 'Viewlet.setBounds';
const SetDom2 = 'Viewlet.setDom2';
const SetUid = 'Viewlet.setUid';
const SetEventListeners = 'Viewlet.registerEventListeners';

const renderBounds = (oldState, newState) => {
  const {
    height,
    uid,
    width,
    x,
    y
  } = newState;
  return [SetBounds, uid, x, y, width, height];
};

const renderContent = (oldState, newState) => {
  const {
    uid
  } = newState;
  const dom = [];
  return [SetDom2, uid, dom];
};

const HandleWheel = 'handleWheel';
const HandleClick = 'handleClick';
const HandleFocusIn = 'handleFocusIn';

const getEventListeners = () => {
  return [{
    name: HandleWheel,
    params: ['EditorCompletion.handleWheel', 'event.deltaMode', 'event.deltaY'],
    passive: true
  }];
};

const renderEventListeners = state => {
  const {
    uid
  } = state;
  const eventListeners = getEventListeners();
  return [SetEventListeners, uid, eventListeners];
};

const renderFocusContext = (oldState, newState) => {
  return [/* method */'Viewlet.setFocusContext', FocusEditorRename];
};

const EditorSourceActions = 'EditorSourceActions';
const EditorSourceActionsList = 'EditorSourceActionsList';
const MaskIcon = 'MaskIcon';
const MaskIconSymbolFile = 'MaskIconSymbolFile';
const SourceActionHeading = 'SourceActionHeading';
const SourceActionIcon = 'SourceActionIcon';
const SourceActionItem = 'SourceActionItem';
const SourceActionItemFocused = 'SourceActionItemFocused';
const Viewlet = 'Viewlet';

const emptyObject = {};
const RE_PLACEHOLDER = /\{(PH\d+)\}/g;
const i18nString = (key, placeholders = emptyObject) => {
  if (placeholders === emptyObject) {
    return key;
  }
  const replacer = (match, rest) => {
    return placeholders[rest];
  };
  return key.replaceAll(RE_PLACEHOLDER, replacer);
};

const NoCodeActionsAvailable = 'No code actions available';
const SourceAction = 'Source Action';

const sourceAction = () => {
  return i18nString(SourceAction);
};
const noCodeActionsAvailable = () => {
  return i18nString(NoCodeActionsAvailable);
};

const Div = 4;

const getEditorMessageVirtualDom = message => {
  const dom = [{
    childCount: 2,
    className: 'Viewlet EditorMessage',
    tabIndex: -1,
    type: Div
  }, {
    childCount: 1,
    className: 'EditorMessageText',
    type: Div
  }, text(message), {
    childCount: 0,
    className: 'EditorMessageTriangle',
    type: Div
  }];
  return dom;
};

const getEmptySourceActionsVirtualDom = () => {
  return getEditorMessageVirtualDom(noCodeActionsAvailable());
};

const getActionClassName = isFocused => {
  if (isFocused) {
    return mergeClassNames(SourceActionItem, SourceActionItemFocused);
  }
  return SourceActionItem;
};
const getSourceActionListItemVirtualDom = sourceAction => {
  const {
    isFocused,
    name
  } = sourceAction;
  const actionClassName = getActionClassName(isFocused);
  return [{
    childCount: 2,
    className: actionClassName,
    type: Div
  }, {
    className: mergeClassNames(SourceActionIcon, MaskIcon, MaskIconSymbolFile),
    type: Div
  }, text(name)];
};

const getSourceActionsVirtualDom = sourceActions => {
  if (sourceActions.length === 0) {
    return getEmptySourceActionsVirtualDom();
  }
  const dom = [{
    childCount: 2,
    className: mergeClassNames(Viewlet, EditorSourceActions),
    onFocusIn: HandleFocusIn,
    tabIndex: -1,
    type: Div
  }, {
    childCount: 1,
    className: SourceActionHeading,
    type: Div
  }, text(sourceAction()), {
    childCount: sourceActions.length,
    className: EditorSourceActionsList,
    onClick: HandleClick,
    type: Div
  }, ...sourceActions.flatMap(getSourceActionListItemVirtualDom)];
  return dom;
};

const renderItems = (oldState, newState) => {
  const dom = [...getSourceActionsVirtualDom(newState.items)];
  return [/* method */'Viewlet.setDom2', newState.uid, dom];
};

const renderUid = (oldState, newState) => {
  const {
    editorUid,
    uid
  } = newState;
  return [SetUid, uid, editorUid];
};

const getRenderer = diffType => {
  switch (diffType) {
    case RenderBounds:
      return renderBounds;
    case RenderContent:
      return renderContent;
    case RenderEventListeners:
      return renderEventListeners;
    case RenderFocusContext:
      return renderFocusContext;
    case RenderItems:
      return renderItems;
    case RenderUid:
      return renderUid;
    default:
      throw new Error('unknown renderer');
  }
};

const applyRender = (oldState, newState, diffResult) => {
  const commands = [];
  for (const item of diffResult) {
    const fn = getRenderer(item);
    commands.push(fn(oldState, newState));
  }
  return commands;
};

const render2 = (uid, diffResult) => {
  const {
    newState,
    oldState
  } = get(uid);
  set$1(uid, newState, newState);
  const commands = applyRender(oldState, newState, diffResult);
  return commands;
};

const applyEdit = async (editorUid, changes) => {
  // @ts-ignore
  await invoke$1('Editor.applyDocumentEdits', editorUid, changes);
};

const getEdits = async editorId => {
  // @ts-ignore
  const edits = await invoke('ExtensionHostOrganizeImports.execute', editorId);
  return edits;
};

const OrganizeImports = 'Organize Imports';

const selectItem = async (state, name) => {
  const {
    editorUid
  } = state;
  if (name === OrganizeImports) {
    const edits = await getEdits(editorUid);
    await applyEdit(editorUid, edits);
  }
  return close(state);
};

const commandMap = {
  'SourceActions.close': wrapCommand(close),
  'SourceActions.create': create,
  'SourceActions.diff2': diff2,
  'SourceActions.dispose': dispose,
  'SourceActions.getCommandIds': getCommandIds,
  'SourceActions.getKeyBindings': getKeyBindings,
  'SourceActions.handleEditorDeleteLeft': wrapCommand(handleEditorDeleteLeft),
  'SourceActions.handleEditorType': wrapCommand(handleEditorType),
  'SourceActions.handleWheel': wrapCommand(handleWheel),
  'SourceActions.initialize': initialize,
  'SourceActions.loadContent': wrapCommand(loadContent),
  'SourceActions.render2': render2,
  'SourceActions.selectItem': wrapCommand(selectItem),
  'SourceActions.terminate': terminate
};

const listen = async () => {
  registerCommands(commandMap);
  const rpc = await WebWorkerRpcClient.create({
    commandMap: commandMap
  });
  set$2(rpc);
};

const main = async () => {
  await listen();
};

main();
